package cz.cvut.kbss.reporting.rest;

import cz.cvut.kbss.reporting.rest.exception.BadRequestException;
import cz.cvut.kbss.reporting.service.OptionsService;
import cz.cvut.kbss.reporting.util.Constants;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/options")
public class OptionsController extends AbstractController {

    private final OptionsService optionsService;

    @Autowired
    public OptionsController(OptionsService optionsService) {
        this.optionsService = optionsService;
    }

    @RequestMapping(method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
    public Object getOptions(@RequestParam MultiValueMap<String, String> params) {
        if (!params.containsKey(Constants.OPTIONS_TYPE_QUERY_PARAM)) {
            throw new BadRequestException("Missing options type parameter - \'type\'.");
        }
        return optionsService.getOptions(params.getFirst(Constants.OPTIONS_TYPE_QUERY_PARAM));
    }
}
