import React from "react";
import Reflux from "reflux";
import PropTypes from "prop-types";
import {Button, Glyphicon, Label} from "react-bootstrap";
import Typeahead from "react-bootstrap-typeahead";

import Actions from "../../actions/Actions";
import I18nWrapper from "../../i18n/I18nWrapper";
import injectIntl from "../../utils/injectIntl";
import TypeaheadResultList from "../typeahead/TypeaheadResultList";

class Tags extends Reflux.Component {

    constructor(props) {
        super(props);
        this.i18n = props.i18n;
        this.state = {renderCreateButton: false};
    }

    _onAddTag = (tag) => {
        this.typeahead.resetSelection();
    };

    _onCreateTag = () => {
    };

    _onRemoveTag = (tag) => {
    };

    _onTagEntryChange = (e) => {
        if (e.target.value !== '') {
            this.setState({renderCreateButton: true});
        } else {
            this.setState({renderCreateButton: false});
        }
    };

    render() {
        return <div>
            <div><label className='control-label'>{this.i18n('tags.header')}</label></div>

            <div className='tags'>
            </div>
            <div className='row'>
                <div className='col-xs-2'>
                    <Typeahead ref={c => this.typeahead = c} onOptionSelected={this._onAddTag}
                               placeholder={this.i18n('tags.search.placeholder')} size='small'
                               filterOption='name' displayOption='name' formInputOption='id'
                               customListComponent={TypeaheadResultList} onChange={this._onTagEntryChange}/>
                </div>
            </div>
        </div>;
    }
}

Tags.propTypes = {
    tags: PropTypes.array,
    onChange: PropTypes.func.isRequired
};

Tags.defaultProps = {
    tags: []
};

export default injectIntl(I18nWrapper(Tags));
